/*
 * This file is part of the Siruna project.
 * Copyright (c) 2007-2009 Mobixx
 * Authors:   Jan Hollez, Dieter Van de Walle, Davy Van Deursen, Gregory De Jans
 * Technical Management & Software Architecture: Frank Gielen
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published
 * by the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE
 * COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY MOBIXX, MOBIXX DISCLAIMS
 * THE WARRANTY OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License
 * for more details.
 *
 * You should have received a copy of the GNU Affero General Public License along with
 * this program; if not, see http://www.gnu.org/licenses or write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA, or download the license from the following URL:
 *
 * http://open.siruna.org/content/terms-use
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License,
 * these Appropriate Legal Notices must retain the display of the "Powered by
 * Siruna" logo. If the display of the logo is not reasonably feasible for
 * technical reasons, the Appropriate Legal Notices must display the words
 * "Powered by Siruna".
 *
 * You can be released from these requirements by purchasing a commercial
 * license. Buying such a license is in most cases mandatory as soon as
 * you develop commercial activities involving the Siruna software.
 * Commercial activities include: offering paid services as a web agency,
 * providing mobile websites for paying or non-paying customers, using
 * the Siruna software in a server farm.
 *
 * For more information, please contact Siruna at this address:
 * contact@siruna.com
 *
 */
var quickHilighting = true;
var fullHighlighting = false;



/***************************************************************************************
 *                              Client-side transformations                            *
 ***************************************************************************************/

function adaptScreensize(width, height, userAgent, uaprof){
  var murl = getMurl();
	var imageWidth = width / 0.6997;
	var left = imageWidth * 0.1501;
	
	
	if (width < 180){
        $('#mobilepreview').css('width', 420);
    } else {
        $('#mobilepreview').css('width', 600);
    }
	$('#preview-top').css('width', imageWidth);
	$('#preview-middle').css('width', imageWidth);
	$('#preview-middle').css('height', height - 73);
	$('#preview-iframe').css('width', width);
	$('#preview-iframe').css('height', height);
	$('#preview-iframe').css('top', -1  - height);
	$('#preview-iframe').css('left', left);
	$('#preview-bottom').css('width', imageWidth);
	$('#preview-bottom').css('top', 0 - height);
  
  updateModel(uaprof, userAgent, murl);

    if (width < 240) {
        var fontsize = width * 100 / 240;
        $(frames['preview'].document).find(body).css('text-size',fontsize + '%');
        
    }
        
}

function changePreview(murl, width, height, imageWidth, left, uaprof, userAgent){
      if (width < 180){
        $('#mobilepreview').css('width', 420);
      } else {
        $('#mobilepreview').css('width', 600);
      }
      $('#preview-top').css('width', imageWidth);
      $('#preview-middle').css('width', imageWidth);
      $('#preview-middle').css('height', height - 73);
      $('#preview-iframe').css('width', width);
      $('#preview-iframe').css('height', height);
      $('#preview-iframe').css('top', -1  - height);
      $('#preview-iframe').css('left', left);
      $('#preview-bottom').css('width', imageWidth);
      $('#preview-bottom').css('top', 0 - height);
      
      updateModel(uaprof, userAgent, murl);
      //loadHtmlInPreview(site, uaprof, userAgent);
}

function transformLinks(context) {
	//load keyEvents so that we can use altDown
	//context.find('head').append('<script type="text/javascript" src="/ComposerWAR/js/keyEvents.js"></script>');
	
	
	//check which modifier keys are pressed
	context.keydown(function(event){
		//console.log('key pressed' + event.keyCode);
		if(event.keyCode == 16) {
				//console.log('shift pressed');
				shiftDown = true;
			} else if(event.keyCode == 17) {
				//console.log('ctrl pressed');
				controlDown = true;
			} else if(event.keyCode == 18) {
				//console.log('alt pressed');
				altDown = true;
			}
	});

	//check which modifier keys are released
	context.keyup(function(event){ //why does context.find('window') not work?
		//console.log('key unpressed' + event.keyCode);
		if(event.keyCode == 16) {
				//console.log('shift pressed');
				shiftDown = false;
			} else if(event.keyCode == 17) {
				//console.log('ctrl released');
				controlDown = false;
			} else if(event.keyCode == 18) {
				//console.log('alt released');
				altDown = false;
			}
	});
	
	
	var links = context.find('a');
	
	links.click(function(){
		if (altDown) {
			console.log('link followed');
			//$(this).attr('href') should be parsed and only site value should be added
			var href = $(this).attr('href');
			var url = href.substring(href.indexOf("_http/")+6, href.length);
			window.location = '/ComposerWAR/secure/sitemapComposer.jsp?site=http://' + url;
			//TODO: complete reload is not necessary (better perceived performance)
			return false;
		} else {
			console.log('link not clickable');
			return false;
		}
	});
	

	var input = context.find('input');
	input.click(function(){
		if (altDown) {
			console.log('button followed');
			//TODO: get form action and switch tab if necessary
			return true;
		} else {
			console.log('button not clickable');
			return false;
		}
	});
	
}

//true means links will be disabled
function showClickableLinks(xHow){	
    //html element on which GUI actions will be done
    var actionElement = document.getElementById('gsmTranscodedView');
	
	objLinks = actionElement.getElementsByTagName("a");
	alert(xHow + ' ' + objLinks[0]);
	for(i=0;i<objLinks.length;i++){
		objLinks[i].disabled = xHow;
		//link with onclick
		if(objLinks[i].onclick && xHow){  
		    objLinks[i].onclick = new Function("return false;" + objLinks[i].onclick.toString().getFuncBody());
		}
		//link without onclick
		else if(xHow){  
		  objLinks[i].onclick = function(){return false;};
		}
		//remove return false with link without onclick
		else if(!xHow && objLinks[i].onclick.toString().indexOf("function(){return false;}") != -1){            
		  objLinks[i].onclick = null;
		}
		//remove return false link with onclick
		else if(!xHow && objLinks[i].onclick.toString().indexOf("return false;") != -1){  
		  strClick = objLinks[i].onclick.toString().getFuncBody().replace("return false;","");
		  objLinks[i].onclick = new Function(strClick);
		}
	}
}

String.prototype.getFuncBody = function(){ 
  var str=this.toString(); 
  str=str.replace(/[^{]+{/,"");
  str=str.substring(0,str.length-1);   
  str = str.replace(/\n/gi,"");
  if(!str.match(/\(.*\)/gi))str += ")";
  return str; 
}


function addTemplate(){
	$('#gsmViews').hide();
}

function transcodeErrorPage(errorPage) {
	if (errorPage.find('body h1').text() == 'An error has occured') {
		//errorPage.find('body h1').css('font-size','75%');
		console.log('Errorpage: ' + errorPage.find('body h1').text());
		errorPage.find('body').css('font-size',11);
		errorPage.find('body').css('margin',0);
		errorPage.find('body td').css('font-size',11); //this should not be necessary
		errorPage.find('body img').css('width',230);
		//console.log('Errorpage');
	}
}

function addSelection(context,selectableItems,callback) {
	
  context.find('head').append('<link rel="stylesheet" href="/ComposerWAR/css/highlighting.css" type="text/css" />');
	
  var govSelectedItem = null;
  var govHovering = false;
  var govHoverElement = null;
	
  //console.log('addSelection(' + context + ',' + selectableItems + ','+ infoDiv + ','+ callback + ')');
  context.find(selectableItems) //select selectableItems in the given context
	  .mouseover( function(eventObject) {
	  			    if(this == govSelectedItem)return; //don't do anything if we hover over the selected item
	  			    if(govHovering)return; //only select one item (the smallest)
		   		    
					//console.log('context: ' + context + ' ' + context[0]);
					highlightElement(context,$(this));
	   			    govHovering = true;
	   			    govHoverElement = this;
	   		  	    //$(infoDiv).html('Path: ' + getAbsoluteXPathFromElement(this)); //display xpath info
		    	  //ev.stopPropagation();
				})
	  .mouseout( function(eventObject) {
				   if(this == govSelectedItem)return;
				   if(!govHovering)return;
				   if(govHoverElement!=this)return;
		    	   
				   removeHighlight(context,$(this));
		    	   govHovering = false;
		    	   govHoverElement = null;
				})
	  .click( function(eventObject) {
				if(!govHovering)return;
				if(govHoverElement!=this)return;
					  		    		  
		    	if (this != govSelectedItem) { //a new selection
		    	  if (govSelectedItem != null) { //unselected previously selected item
		    		$(govSelectedItem).css("outline", "none");
		    	  }
		    	  //govSelectedItem.css("outline","none");
		    	  $(this).css("outline", "2px solid blue");
		    	  govSelectedItem = this;
		    		    
		    	  govHovering = false; //allowo ther items to be hovered and selected
		    	  govHoverElement = null;
				  
				  callback(this);
		    	}
			 });
														  			
	  //console.log("frames['gsmOriginalView'].document" + $(frames['gsmOriginalView'].document).find('div,p'));
	}
	
function removeHighlight(context,element) {
	if (quickHilighting) {
		element.css("outline", "none");
	} else {
		context.find('.itemHovered').remove();
		context.find('.itemHovered2').remove();
	}
}	
	
function highlightElement(context, element){
	if (quickHilighting) {
		element.css("outline", "2px dashed blue");
	} else if (fullHighlighting) {
		var offset = element.offset();
		var width = element.width();
		var height = element.height();
		var style = 'left: ' + offset.left + 'px; top: ' + offset.top + 'px; width: ' + width + 'px;height: ' + height + 'px;';
		context.find('body').prepend('<div style="' + style + '" class="itemHovered2"></div>');
	}
	else {
		removeHighlight(context);
		
		var offset = element.offset();
		var width = element.width();
		var height = element.height();
		var lineWidth = 2;
		
		var top = 'left: ' + offset.left + 'px; top: ' + offset.top + 'px; width: ' + width + 'px;height: ' + lineWidth + 'px;';
		var bottom = 'left: ' + offset.left + 'px; top: ' + (offset.top + height -1) + 'px; width: ' + width + 'px;height: ' + lineWidth + 'px;';
		var left = 'left: ' + offset.left + 'px; top: ' + offset.top + 'px; width: ' + lineWidth + 'px;height: ' + height + 'px;';
		var right = 'left: ' + (offset.left + width) + 'px; top: ' + offset.top + 'px; width: ' + lineWidth + 'px;height: ' + height + 'px;';
		//<div style="left: 0px; top: -2px; width: 1267px; height: 2px;" class="outline"></div>
		//<div style="left: 1267px; top: -2px; width: 2px; height: 92px;" class="outline"></div>
		//<div style="left: 0px; top: 88px; width: 1267px; height: 2px;" class="outline"></div>
		//<div style="left: -2px; top: -2px; width: 2px; height: 92px;" class="outline"></div>
		
		addDiv(context, top);
		addDiv(context, bottom);
		addDiv(context, left);
		addDiv(context, right);
	}
}

function addDiv(context,style){
	context.find('body').prepend('<div style="' + style + '" class="itemHovered"></div>');
}
